## wabt 1.0.30

=== CMakeLists.txt ===
#
# Copyright 2016 WebAssembly Community Group participants
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.16)
project(WABT LANGUAGES C CXX VERSION 1.0.30)

include(GNUInstallDirs)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Check if wabt is being used directly or via add_subdirectory, FetchContent, etc
string(COMPARE EQUAL "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_SOURCE_DIR}" PROJECT_IS_TOP_LEVEL)

# By default use the project version as the version string
set(WABT_VERSION_STRING "${PROJECT_VERSION}")

# For git users, attempt to generate a more useful version string
if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
  find_package(Git)
  if (Git_FOUND)
    execute_process(
      COMMAND "${GIT_EXECUTABLE}" -C "${WABT_SOURCE_DIR}" describe --tags
      RESULT_VARIABLE GIT_VERSION_RESULT
      ERROR_VARIABLE GIT_VERSION_ERROR
      ERROR_STRIP_TRAILING_WHITESPACE
      OUTPUT_VARIABLE GIT_VERSION
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if (GIT_VERSION_RESULT EQUAL 0)
      # If we're actually on the tag for this version, don't add the commit description
      if (NOT GIT_VERSION STREQUAL "${WABT_VERSION_STRING}")
        string(APPEND WABT_VERSION_STRING " (git~${GIT_VERSION})")
      endif ()
    elseif (PROJECT_IS_TOP_LEVEL)
      message(NOTICE "git: ${GIT_VERSION_ERROR}\n  ** Did you forget to run `git fetch --tags`?")
    endif ()
  endif ()
endif ()

option(BUILD_TESTS "Build GTest-based tests" ON)
option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
option(BUILD_TOOLS "Build wabt commandline tools" ON)
option(BUILD_FUZZ_TOOLS "Build tools that can repro fuzz bugs" OFF)
option(BUILD_LIBWASM "Build libwasm" ON)
option(USE_ASAN "Use address sanitizer" OFF)
option(USE_MSAN "Use memory sanitizer" OFF)
option(USE_LSAN "Use leak sanitizer" OFF)
option(USE_UBSAN "Use undefined behavior sanitizer" OFF)
option(CODE_COVERAGE "Build with code coverage enabled" OFF)
option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)
option(WERROR "Build with warnings as errors" OFF)
option(WABT_INSTALL_RULES "Include WABT's install() rules" "${PROJECT_IS_TOP_LEVEL}")
# WASI support is still a work in progress.
# Only a handful of syscalls are supported at this point.
option(WITH_WASI "Build WASI support via uvwasi" OFF)

if (MSVC)
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 1)
elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(COMPILER_IS_CLANG 1)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
elseif (CMAKE_C_COMPILER_ID STREQUAL "GNU")
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 1)
  set(COMPILER_IS_MSVC 0)
elseif (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(COMPILER_IS_CLANG 1)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
else ()
  set(COMPILER_IS_CLANG 0)
  set(COMPILER_IS_GNU 0)
  set(COMPILER_IS_MSVC 0)
endif ()

include(CheckIncludeFile)
include(CheckSymbolExists)

check_include_file("alloca.h" HAVE_ALLOCA_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)

if (WIN32)
  check_symbol_exists(ENABLE_VIRTUAL_TERMINAL_PROCESSING "windows.h" HAVE_WIN32_VT100)
endif ()

include(CheckTypeSize)
check_type_size(ssize_t SSIZE_T)
check_type_size(size_t SIZEOF_SIZE_T)

include(TestBigEndian)  # Note: deprecated in CMake 3.20
test_big_endian(WABT_BIG_ENDIAN)

configure_file(src/config.h.in include/wabt/config.h @ONLY)


if (COMPILER_IS_MSVC)
  if (WERROR)
    add_definitions(-WX)
  endif ()

  # disable warning C4018: signed/unsigned mismatch
  # disable warning C4056, C4756: overflow in floating-point constant arithmetic
  #   seems to not like float compare w/ HUGE_VALF; bug?
  # disable warnings C4267 and C4244: conversion/truncation from larger to smaller type.
  # disable warning C4800: implicit conversion from larger int to bool
  add_definitions(-W3 -wd4018 -wd4056 -wd4756 -wd4267 -wd4244 -wd4800 -D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)

  if (NOT WITH_EXCEPTIONS)
    # disable exception use in C++ library
    add_definitions(-D_HAS_EXCEPTIONS=0)
  endif ()

  # multi-core build.
  add_definitions("/MP")

else ()
  if (WERROR)
    add_definitions(-Werror)
  endif ()

  # disable -Wunused-parameter: this is really common when implementing
  #   interfaces, etc.
  # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
  add_definitions(
    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -Wuninitialized
  )

  set(CMAKE_CXX_EXTENSIONS OFF)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wold-style-cast")

  if (NOT WITH_EXCEPTIONS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
  endif ()

  # Need to define __STDC_*_MACROS because C99 specifies that C++ shouldn't
  # define format (e.g. PRIu64) or limit (e.g. UINT32_MAX) macros without the
  # definition, and some libcs (e.g. glibc2.17 and earlier) follow that.
  add_definitions(-D__STDC_LIMIT_MACROS=1 -D__STDC_FORMAT_MACROS=1)

  if (MINGW OR CYGWIN)
    # On MINGW, _POSIX_C_SOURCE is needed to ensure we use mingw printf
    # instead of the VC runtime one.
    add_definitions(-D_POSIX_C_SOURCE=200809L)
  endif()

  if (COMPILER_IS_GNU)
    # disable -Wclobbered: it seems to be guessing incorrectly about a local
    # variable being clobbered by longjmp.
    add_definitions(-Wno-clobbered)
  endif ()

  # wasm doesn't allow for x87 floating point math
  if (NOT EMSCRIPTEN)
    check_symbol_exists(__i386__ "" TARGET_IS_X86_32)
    check_symbol_exists(__SSE2_MATH__ "" HAVE_SSE2_MATH)

    if (TARGET_IS_X86_32 AND NOT HAVE_SSE2_MATH)
      if (COMPILER_IS_GNU OR COMPILER_IS_CLANG)
        add_compile_options(-msse2 -mfpmath=sse)
      else ()
        message(
          WARNING
          "Unknown compiler ${CMAKE_CXX_COMPILER_ID} appears to target x86-32 with x87 "
          "math. If you want wasm2c to work in a spec-compliant way, please add flags to "
          "use SSE2 math and set TARGET_IS_X86_32 and HAVE_SSE2_MATH appropriately at the "
          "CMake command line."
        )
      endif ()
    endif ()
  endif ()
endif ()

set(USE_SANITIZER FALSE)

function(sanitizer NAME FLAGS)
  if (${NAME})
    if (USE_SANITIZER)
      message(FATAL_ERROR "Only one sanitizer allowed")
    endif ()
    set(USE_SANITIZER TRUE PARENT_SCOPE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS}" PARENT_SCOPE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}" PARENT_SCOPE)
  endif ()
endfunction()
sanitizer(USE_ASAN "-fsanitize=address")
sanitizer(USE_MSAN "-fsanitize=memory")
sanitizer(USE_LSAN "-fsanitize=leak")

if (USE_UBSAN)
  # -fno-sanitize-recover was deprecated, see if we are compiling with a newer
  # clang that requires -fno-sanitize-recover=all.
  set(UBSAN_BLACKLIST ${WABT_SOURCE_DIR}/ubsan.blacklist)
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover -Wall -Werror" HAS_UBSAN_RECOVER_BARE)
  if (HAS_UBSAN_RECOVER_BARE)
    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
  endif ()
  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
  # If we already setup UBSAN recover bare, setting it up again here will be an error.
  if (NOT USE_SANITIZER AND HAS_UBSAN_RECOVER_ALL)
    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
  endif ()
  if (NOT USE_SANITIZER)
    message(FATAL_ERROR "UBSAN is not supported")
  endif ()
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${WABT_SOURCE_DIR}/cmake)

add_custom_target(everything)

set(WABT_LIBRARY_CC
  src/apply-names.cc
  src/binary-reader-ir.cc
  src/binary-reader-logging.cc
  src/binary-reader.cc
  src/binary-writer-spec.cc
  src/binary-writer.cc
  src/binary.cc
  src/binding-hash.cc
  src/color.cc
  src/common.cc
  src/config.cc
  src/config.h.in
  src/decompiler.cc
  src/error-formatter.cc
  src/expr-visitor.cc
  src/feature.cc
  src/filenames.cc
  src/generate-names.cc
  src/ir-util.cc
  src/ir.cc
  src/leb128.cc
  src/lexer-source-line-finder.cc
  src/lexer-source.cc
  src/literal.cc
  src/opcode-code-table.c
  src/opcode.cc
  src/option-parser.cc
  src/resolve-names.cc
  src/shared-validator.cc
  src/stream.cc
  src/token.cc
  src/tracing.cc
  src/type-checker.cc
  src/utf8.cc
  src/validator.cc
  src/wast-lexer.cc
  src/wast-parser.cc
  src/wat-writer.cc

  # TODO(binji): Move this into its own library?
  src/interp/binary-reader-interp.cc
  src/interp/interp.cc
  src/interp/interp-util.cc
  src/interp/istream.cc
)

set(WABT_LIBRARY_H
  ${WABT_BINARY_DIR}/include/wabt/config.h

  include/wabt/apply-names.h
  include/wabt/binary-reader-ir.h
  include/wabt/binary-reader-logging.h
  include/wabt/binary-reader.h
  include/wabt/binary-writer-spec.h
  include/wabt/binary-writer.h
  include/wabt/binary.h
  include/wabt/binding-hash.h
  include/wabt/color.h
  include/wabt/common.h
  include/wabt/decompiler-ast.h
  include/wabt/decompiler-ls.h
  include/wabt/decompiler-naming.h
  include/wabt/decompiler.h
  include/wabt/error-formatter.h
  include/wabt/expr-visitor.h
  include/wabt/feature.h
  include/wabt/filenames.h
  include/wabt/generate-names.h
  include/wabt/ir-util.h
  include/wabt/ir.h
  include/wabt/leb128.h
  include/wabt/lexer-source-line-finder.h
  include/wabt/lexer-source.h
  include/wabt/literal.h
  include/wabt/opcode-code-table.h
  include/wabt/opcode.h
  include/wabt/option-parser.h
  include/wabt/resolve-names.h
  include/wabt/shared-validator.h
  include/wabt/stream.h
  include/wabt/string-util.h
  include/wabt/token.h
  include/wabt/tracing.h
  include/wabt/type-checker.h
  include/wabt/type.h
  include/wabt/utf8.h
  include/wabt/validator.h
  include/wabt/wast-lexer.h
  include/wabt/wast-parser.h
  include/wabt/wat-writer.h

  # TODO(binji): Move this into its own library?
  include/wabt/interp/binary-reader-interp.h
  include/wabt/interp/interp-inl.h
  include/wabt/interp/interp-math.h
  include/wabt/interp/interp-util.h
  include/wabt/interp/interp.h
  include/wabt/interp/istream.h
)

set(WABT_LIBRARY_SRC ${WABT_LIBRARY_CC} ${WABT_LIBRARY_H})

add_library(wabt STATIC ${WABT_LIBRARY_SRC})
add_library(wabt::wabt ALIAS wabt)

target_compile_features(wabt PUBLIC cxx_std_17)
target_include_directories(
  wabt
  PUBLIC
  "$<BUILD_INTERFACE:${WABT_SOURCE_DIR}/include>"
  "$<BUILD_INTERFACE:${WABT_BINARY_DIR}/include>"
)

if (WABT_INSTALL_RULES)
  install(
    TARGETS wabt EXPORT wabt-targets
    COMPONENT wabt-development
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
  )
  install(
    DIRECTORY "${WABT_SOURCE_DIR}/include/" "${WABT_BINARY_DIR}/include/"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    COMPONENT wabt-development
  )
endif ()

IF (NOT WIN32)
  add_library(wasm-rt-impl STATIC wasm2c/wasm-rt-impl.c wasm2c/wasm-rt-impl.h)
  add_library(wabt::wasm-rt-impl ALIAS wasm-rt-impl)
  if (WABT_BIG_ENDIAN)
    target_compile_definitions(wasm-rt-impl PUBLIC WABT_BIG_ENDIAN=1)
  endif ()

  if (WABT_INSTALL_RULES)
    install(
      TARGETS wasm-rt-impl
      EXPORT wabt-targets
      COMPONENT wabt-development
      INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
    )
    install(
      FILES "wasm2c/wasm-rt-impl.h" "wasm2c/wasm-rt.h"
      TYPE INCLUDE
      COMPONENT wabt-development
    )
  endif ()
endif ()

=== debian/changelog ===
wabt (1.0.30-1) unstable; urgency=medium

  * New upstream version 1.0.30.

 -- Markus Koschany <apo@debian.org>  Thu, 13 Oct 2022 23:23:14 +0200

=== debian/control ===
Source: wabt
Section: devel
Priority: optional
Maintainer: Markus Koschany <apo@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 python3,
 re2c
Standards-Version: 4.6.1
Homepage: https://github.com/WebAssembly/wabt
Vcs-Git: https://salsa.debian.org/debian/wabt.git
Vcs-Browser: https://salsa.debian.org/debian/wabt

Package: wabt
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: WebAssembly Binary Toolkit
 WABT (pronounced: "wabbit") is a suite of tools for WebAssembly, including:
 .
  * wat2wasm: translate from WebAssembly text format to the WebAssembly binary
    format
  * wasm2wat: the inverse of wat2wasm, translate from the binary format back
    to the text format (also known as a .wat)
  * wasm-objdump: print information about a wasm binary. Similar to objdump.
  * wasm-interp: decode and run a WebAssembly binary file using a stack-based
    interpreter
  * wat-desugar: parse .wat text form as supported by the spec interpreter
    (s-expressions, flat syntax, or mixed) and print "canonical" flat format
  * wasm2c: convert a WebAssembly binary file to a C source and header
 .
 These tools are intended for use in (or for development of) toolchains or
 other systems that want to manipulate WebAssembly files. Unlike the
 WebAssembly spec interpreter (which is written to be as simple, declarative
 and "speccy" as possible), they are written in C/C++ and designed for easier
 integration into other systems. Unlike Binaryen these tools do not aim to
 provide an optimization platform or a higher-level compiler target; instead
 they aim for full fidelity and compliance with the spec (e.g. 1:1 round-trips
 with no changes to instructions).

## wabt 1.0.31

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.30)
+project(WABT LANGUAGES C CXX VERSION 1.0.31)
 
 include(GNUInstallDirs)
 
@@ -227,6 +227,25 @@
 endif ()
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${WABT_SOURCE_DIR}/cmake)
+
+# CWriter code templates
+set(TEMPLATE_CMAKE ${WABT_SOURCE_DIR}/scripts/gen-wasm2c-templates.cmake)
+
+add_custom_command(
+  OUTPUT wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc
+
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_top.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.top.h" -D symbol="s_header_top" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_bottom.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h" -D symbol="s_header_bottom" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
+
+  DEPENDS ${WABT_SOURCE_DIR}/src/template/wasm2c.top.h
+  ${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h
+  ${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c
+  ${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c
+)
+
+set(CWRITER_TEMPLATE_SRC wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc)
 
 add_custom_target(everything)
 
@@ -269,6 +288,8 @@
   src/wast-lexer.cc
   src/wast-parser.cc
   src/wat-writer.cc
+  src/c-writer.cc
+  ${CWRITER_TEMPLATE_SRC}
 
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.cc
@@ -328,54 +349,3 @@
   include/wabt/interp/interp-math.h
   include/wabt/interp/interp-util.h
   include/wabt/interp/interp.h
-  include/wabt/interp/istream.h
-)
-
-set(WABT_LIBRARY_SRC ${WABT_LIBRARY_CC} ${WABT_LIBRARY_H})
-
-add_library(wabt STATIC ${WABT_LIBRARY_SRC})
-add_library(wabt::wabt ALIAS wabt)
-
-target_compile_features(wabt PUBLIC cxx_std_17)
-target_include_directories(
-  wabt
-  PUBLIC
-  "$<BUILD_INTERFACE:${WABT_SOURCE_DIR}/include>"
-  "$<BUILD_INTERFACE:${WABT_BINARY_DIR}/include>"
-)
-
-if (WABT_INSTALL_RULES)
-  install(
-    TARGETS wabt EXPORT wabt-targets
-    COMPONENT wabt-development
-    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
-  )
-  install(
-    DIRECTORY "${WABT_SOURCE_DIR}/include/" "${WABT_BINARY_DIR}/include/"
-    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
-    COMPONENT wabt-development
-  )
-endif ()
-
-IF (NOT WIN32)
-  add_library(wasm-rt-impl STATIC wasm2c/wasm-rt-impl.c wasm2c/wasm-rt-impl.h)
-  add_library(wabt::wasm-rt-impl ALIAS wasm-rt-impl)
-  if (WABT_BIG_ENDIAN)
-    target_compile_definitions(wasm-rt-impl PUBLIC WABT_BIG_ENDIAN=1)
-  endif ()
-
-  if (WABT_INSTALL_RULES)
-    install(
-      TARGETS wasm-rt-impl
-      EXPORT wabt-targets
-      COMPONENT wabt-development
-      INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
-    )
-    install(
-      FILES "wasm2c/wasm-rt-impl.h" "wasm2c/wasm-rt.h"
-      TYPE INCLUDE
-      COMPONENT wabt-development
-    )
-  endif ()
-endif ()
-

=== debian/changelog ===
wabt (1.0.31-1) unstable; urgency=medium

  * New upstream version 1.0.31.

 -- Markus Koschany <apo@debian.org>  Mon, 28 Nov 2022 22:31:48 +0100

## wabt 1.0.32

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.31)
+project(WABT LANGUAGES C CXX VERSION 1.0.32)
 
 include(GNUInstallDirs)
 
@@ -110,6 +110,10 @@
 
 include(TestBigEndian)  # Note: deprecated in CMake 3.20
 test_big_endian(WABT_BIG_ENDIAN)
+
+if (CMAKE_BUILD_TYPE STREQUAL "Debug")
+  set(WABT_DEBUG 1)
+endif ()
 
 configure_file(src/config.h.in include/wabt/config.h @ONLY)
 
@@ -347,5 +351,3 @@
   include/wabt/interp/binary-reader-interp.h
   include/wabt/interp/interp-inl.h
   include/wabt/interp/interp-math.h
-  include/wabt/interp/interp-util.h
-  include/wabt/interp/interp.h

=== wasm2c/examples/fac/Makefile ===
# Use implicit rules for compiling C files.
CFLAGS=-I../..

all: fac

clean:
	rm -rf fac fac.wasm fac.c *.o

fac: main.o fac.o ../../wasm-rt-impl.o -lm

fac.wasm: fac.wat ../../../bin/wat2wasm
	../../../bin/wat2wasm $< -o $@

fac.c: fac.wasm ../../../bin/wasm2c
	../../../bin/wasm2c $< -o $@

.PHONY: all clean

=== wasm2c/examples/rot13/Makefile ===
# Use implicit rules for compiling C files.
CFLAGS=-I../..

all: rot13

rot13: main.o rot13.o ../../wasm-rt-impl.o

clean:
	rm -rf rot13 rot13.wasm rot13.c *.o

rot13: main.o rot13.o ../../wasm-rt-impl.o -lm

rot13.wasm: rot13.wat ../../../bin/wat2wasm
	../../../bin/wat2wasm $< -o $@

rot13.c: rot13.wasm ../../../bin/wasm2c
	../../../bin/wasm2c $< -o $@

.PHONY: all clean

=== debian/changelog ===
wabt (1.0.32-1) unstable; urgency=medium

  * New upstream version 1.0.32.
  * Declare compliance with Debian Policy 4.6.2.

 -- Markus Koschany <apo@debian.org>  Fri, 13 Jan 2023 00:05:45 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  python3,
  re2c
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt

## wabt 1.0.33

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.32)
+project(WABT LANGUAGES C CXX VERSION 1.0.33)
 
 include(GNUInstallDirs)
 
@@ -69,6 +69,7 @@
 # WASI support is still a work in progress.
 # Only a handful of syscalls are supported at this point.
 option(WITH_WASI "Build WASI support via uvwasi" OFF)
+option(USE_INTERNAL_SHA256 "Use internal PicoSHA2 for SHA-256 support instead of OpenSSL libcrypto" OFF)
 
 if (MSVC)
   set(COMPILER_IS_CLANG 0)
@@ -100,7 +101,23 @@
 check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
 check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)
 
+if (NOT USE_INTERNAL_SHA256)
+  find_package(OpenSSL QUIET)
+  if (OpenSSL_FOUND)
+    set(CMAKE_REQUIRED_INCLUDES ${OPENSSL_INCLUDE_DIR})
+    check_include_file("openssl/sha.h" HAVE_OPENSSL_SHA_H)
+    if (HAVE_OPENSSL_SHA_H)
+      find_package_message(OpenSSL "Using OpenSSL libcrypto for SHA-256" "${HAVE_OPENSSL_SHA_H}")
+    endif()
+  endif()
+endif()
+
 if (WIN32)
+  if(${CMAKE_GENERATOR_PLATFORM} MATCHES "ARM64")
+    # https://discourse.cmake.org/t/visual-studio-error-unable-to-deploy-local-file-c-x64-release-zero-check/2072
+    # Target ZERO_CHECK blocks remote debugger of ARM64 in Visual Studio
+    set(CMAKE_SUPPRESS_REGENERATION ON)
+  endif()
   check_symbol_exists(ENABLE_VIRTUAL_TERMINAL_PROCESSING "windows.h" HAVE_WIN32_VT100)
 endif ()
 
@@ -147,7 +164,7 @@
   #   interfaces, etc.
   # disable -Wpointer-arith: this is a GCC extension, and doesn't work in MSVC.
   add_definitions(
-    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -Wuninitialized
+    -Wall -Wextra -Wno-unused-parameter -Wpointer-arith -Wuninitialized -Wimplicit-fallthrough
   )
 
   set(CMAKE_CXX_EXTENSIONS OFF)
@@ -205,6 +222,7 @@
     set(USE_SANITIZER TRUE PARENT_SCOPE)
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS}" PARENT_SCOPE)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}" PARENT_SCOPE)
+    set(WASM2C_CFLAGS "${WASM2C_CFLAGS} ${FLAGS}" PARENT_SCOPE)
   endif ()
 endfunction()
 sanitizer(USE_ASAN "-fsanitize=address")
@@ -236,20 +254,29 @@
 set(TEMPLATE_CMAKE ${WABT_SOURCE_DIR}/scripts/gen-wasm2c-templates.cmake)
 
 add_custom_command(
-  OUTPUT wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc
-
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_top.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.top.h" -D symbol="s_header_top" -P ${TEMPLATE_CMAKE}
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_header_bottom.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h" -D symbol="s_header_bottom" -P ${TEMPLATE_CMAKE}
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
-  COMMAND ${CMAKE_COMMAND} -D out="wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
+  OUTPUT gen-wasm2c-prebuilt
+
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_top.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.top.h" -D symbol="s_header_top" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_bottom.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h" -D symbol="s_header_bottom" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c" -D symbol="s_simd_source_declarations" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -E touch gen-wasm2c-prebuilt
 
   DEPENDS ${WABT_SOURCE_DIR}/src/template/wasm2c.top.h
   ${WABT_SOURCE_DIR}/src/template/wasm2c.bottom.h
   ${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c
   ${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c
+  ${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c
 )
 
-set(CWRITER_TEMPLATE_SRC wasm2c_header_top.cc wasm2c_header_bottom.cc wasm2c_source_includes.cc wasm2c_source_declarations.cc)
+add_custom_target(gen-wasm2c-prebuilt-target DEPENDS gen-wasm2c-prebuilt)
+
+set(CWRITER_TEMPLATE_SRC ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_top.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_bottom.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc)
 
 add_custom_target(everything)
 
@@ -282,6 +309,7 @@
   src/opcode.cc
   src/option-parser.cc
   src/resolve-names.cc
+  src/sha256.cc
   src/shared-validator.cc
   src/stream.cc
   src/token.cc
@@ -293,61 +321,3 @@
   src/wast-parser.cc
   src/wat-writer.cc
   src/c-writer.cc
-  ${CWRITER_TEMPLATE_SRC}
-
-  # TODO(binji): Move this into its own library?
-  src/interp/binary-reader-interp.cc
-  src/interp/interp.cc
-  src/interp/interp-util.cc
-  src/interp/istream.cc
-)
-
-set(WABT_LIBRARY_H
-  ${WABT_BINARY_DIR}/include/wabt/config.h
-
-  include/wabt/apply-names.h
-  include/wabt/binary-reader-ir.h
-  include/wabt/binary-reader-logging.h
-  include/wabt/binary-reader.h
-  include/wabt/binary-writer-spec.h
-  include/wabt/binary-writer.h
-  include/wabt/binary.h
-  include/wabt/binding-hash.h
-  include/wabt/color.h
-  include/wabt/common.h
-  include/wabt/decompiler-ast.h
-  include/wabt/decompiler-ls.h
-  include/wabt/decompiler-naming.h
-  include/wabt/decompiler.h
-  include/wabt/error-formatter.h
-  include/wabt/expr-visitor.h
-  include/wabt/feature.h
-  include/wabt/filenames.h
-  include/wabt/generate-names.h
-  include/wabt/ir-util.h
-  include/wabt/ir.h
-  include/wabt/leb128.h
-  include/wabt/lexer-source-line-finder.h
-  include/wabt/lexer-source.h
-  include/wabt/literal.h
-  include/wabt/opcode-code-table.h
-  include/wabt/opcode.h
-  include/wabt/option-parser.h
-  include/wabt/resolve-names.h
-  include/wabt/shared-validator.h
-  include/wabt/stream.h
-  include/wabt/string-util.h
-  include/wabt/token.h
-  include/wabt/tracing.h
-  include/wabt/type-checker.h
-  include/wabt/type.h
-  include/wabt/utf8.h
-  include/wabt/validator.h
-  include/wabt/wast-lexer.h
-  include/wabt/wast-parser.h
-  include/wabt/wat-writer.h
-
-  # TODO(binji): Move this into its own library?
-  include/wabt/interp/binary-reader-interp.h
-  include/wabt/interp/interp-inl.h
-  include/wabt/interp/interp-math.h

=== debian/changelog ===
wabt (1.0.33-1) unstable; urgency=medium

  * New upstream version 1.0.33.
  * Build-depend on libssl-dev to provide a SHA-256 implementation
    used by the wasm2c tool.

 -- Markus Koschany <apo@debian.org>  Sat, 01 Jul 2023 15:35:52 +0200

## wabt 1.0.34

=== debian/changelog ===
wabt (1.0.34-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
    Changes-By: lintian-brush Fixes: lintian: trailing-whitespace See-also:
    https://lintian.debian.org/tags/trailing-whitespace.html
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
    Changes-By: lintian-brush
    Fixes: lintian: upstream-metadata-file-is-missing See-also:
    https://lintian.debian.org/tags/upstream-metadata-file-is-missing.html
    Fixes: lintian: upstream-metadata-missing-bug-tracking See-also:
    https://lintian.debian.org/tags/upstream-metadata-missing-bug-tracking.html

  [ Markus Koschany ]
  * Add clean file.
  * Remove the bin directory completely.
  * New upstream version 1.0.34.

 -- Markus Koschany <apo@debian.org>  Mon, 30 Oct 2023 23:28:18 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  cmake,
  debhelper-compat (= 13),
  python3,
+ libssl-dev,
  re2c
 Standards-Version: 4.6.2
 Homepage: https://github.com/WebAssembly/wabt

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTS=OFF

override_dh_clean:
	dh_clean
	$(RM) -r bin

## wabt 1.0.34%2Bdsfg2%2B~cs1.0.32

=== debian/changelog ===
wabt (1.0.34+dsfg2+~cs1.0.32-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:33:42 +1100

wabt (1.0.34+dsfg2+~cs1.0.32-1ubuntu1) noble; urgency=medium

  * Strip "-Wl,-Bsymbolic-functions", making build fail.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 27 Mar 2024 09:26:03 +0100

wabt (1.0.34+dsfg2+~cs1.0.32-1) unstable; urgency=medium

  * Repack in order to get rid of spurious tar
  * Upload to unstable

 -- Bastien Roucariès <rouca@debian.org>  Fri, 16 Feb 2024 18:44:56 +0000

wabt (1.0.34+dsfg+~cs1.0.32-1) experimental; urgency=medium

  [ Bastien Roucariès ]
  * Add Yadd and myself as comaintainer. Thanks Markus
  * Include picosha2 forgotten by upstream
  * Compile wabt.js
  * Add node package

  [ Yadd ]
  * Set upstream metadata fields: Security-Contact.
  * Add "Rules-Requires-Root: no"
  * Add ctype=nodejs to component(s)
  * Update debian/copyright
  * Improve hardening
  * Add lintian overrides
  * Add spelling error patch
  * Exclude fuzz-in/wasm/stuff.wasm and wasm2c/examples/fac/fac.wasm from import

 -- Bastien Roucariès <rouca@debian.org>  Tue, 05 Dec 2023 15:48:51 +0000

## wabt 1.0.34+dsfg2+~cs1.0.32

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #
 
 cmake_minimum_required(VERSION 3.16)
-project(WABT LANGUAGES C CXX VERSION 1.0.33)
+project(WABT LANGUAGES C CXX VERSION 1.0.34)
 
 include(GNUInstallDirs)
 
@@ -98,6 +98,7 @@
 
 check_include_file("alloca.h" HAVE_ALLOCA_H)
 check_include_file("unistd.h" HAVE_UNISTD_H)
+check_include_file("setjmp.h" HAVE_SETJMP_H)
 check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
 check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)
 
@@ -261,6 +262,7 @@
   COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c" -D symbol="s_source_includes" -P ${TEMPLATE_CMAKE}
   COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c" -D symbol="s_source_declarations" -P ${TEMPLATE_CMAKE}
   COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c" -D symbol="s_simd_source_declarations" -P ${TEMPLATE_CMAKE}
+  COMMAND ${CMAKE_COMMAND} -D out="${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_atomicops_source_declarations.cc" -D in="${WABT_SOURCE_DIR}/src/template/wasm2c_atomicops.declarations.c" -D symbol="s_atomicops_source_declarations" -P ${TEMPLATE_CMAKE}
   COMMAND ${CMAKE_COMMAND} -E touch gen-wasm2c-prebuilt
 
   DEPENDS ${WABT_SOURCE_DIR}/src/template/wasm2c.top.h
@@ -268,6 +270,7 @@
   ${WABT_SOURCE_DIR}/src/template/wasm2c.includes.c
   ${WABT_SOURCE_DIR}/src/template/wasm2c.declarations.c
   ${WABT_SOURCE_DIR}/src/template/wasm2c_simd.declarations.c
+  ${WABT_SOURCE_DIR}/src/template/wasm2c_atomicops.declarations.c
 )
 
 add_custom_target(gen-wasm2c-prebuilt-target DEPENDS gen-wasm2c-prebuilt)
@@ -276,7 +279,8 @@
                          ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_header_bottom.cc
                          ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_includes.cc
                          ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_source_declarations.cc
-                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc)
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_simd_source_declarations.cc
+                         ${WABT_SOURCE_DIR}/src/prebuilt/wasm2c_atomicops_source_declarations.cc)
 
 add_custom_target(everything)
 
@@ -298,26 +302,3 @@
   src/expr-visitor.cc
   src/feature.cc
   src/filenames.cc
-  src/generate-names.cc
-  src/ir-util.cc
-  src/ir.cc
-  src/leb128.cc
-  src/lexer-source-line-finder.cc
-  src/lexer-source.cc
-  src/literal.cc
-  src/opcode-code-table.c
-  src/opcode.cc
-  src/option-parser.cc
-  src/resolve-names.cc
-  src/sha256.cc
-  src/shared-validator.cc
-  src/stream.cc
-  src/token.cc
-  src/tracing.cc
-  src/type-checker.cc
-  src/utf8.cc
-  src/validator.cc
-  src/wast-lexer.cc
-  src/wast-parser.cc
-  src/wat-writer.cc
-  src/c-writer.cc

=== wasm2c/examples/callback/Makefile ===
# Use implicit rules for compiling C files.
CFLAGS=-I../..

all: callback

callback: main.o callback.o ../../wasm-rt-impl.o

clean:
	rm -rf callback callback.wasm callback.c callback.h *.o

callback: main.o callback.o ../../wasm-rt-impl.o -lm

callback.wasm: callback.wat ../../../bin/wat2wasm
	../../../bin/wat2wasm --debug-names $< -o $@

callback.c: callback.wasm ../../../bin/wasm2c
	../../../bin/wasm2c $< -o $@ --disable-simd

.PHONY: all clean

=== wasm2c/examples/fac/Makefile ===
--- 
+++ 
@@ -12,6 +12,6 @@
 	../../../bin/wat2wasm $< -o $@
 
 fac.c: fac.wasm ../../../bin/wasm2c
-	../../../bin/wasm2c $< -o $@
+	../../../bin/wasm2c $< -o $@ --disable-simd
 
 .PHONY: all clean

=== wasm2c/examples/rot13/Makefile ===
--- 
+++ 
@@ -14,6 +14,6 @@
 	../../../bin/wat2wasm $< -o $@
 
 rot13.c: rot13.wasm ../../../bin/wasm2c
-	../../../bin/wasm2c $< -o $@
+	../../../bin/wasm2c $< -o $@ --disable-simd
 
 .PHONY: all clean

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,29 @@
 Source: wabt
 Section: devel
 Priority: optional
-Maintainer: Markus Koschany <apo@debian.org>
-Build-Depends:
- cmake,
- debhelper-compat (= 13),
- python3,
- libssl-dev,
- re2c
+Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
+Uploaders: Markus Koschany <apo@debian.org>
+ , Bastien Roucariès <rouca@debian.org>
+ , Yadd <yadd@debian.org>
+Build-Depends: debhelper-compat (= 13)
+ , cmake
+ , dh-nodejs
+ , emscripten
+ , libssl-dev
+ , ninja-build
+ , python3
+ , re2c
 Standards-Version: 4.6.2
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt
+Rules-Requires-Root: no
 
 Package: wabt
 Architecture: any
-Depends:
- ${misc:Depends},
- ${shlibs:Depends}
+Depends: ${misc:Depends}
+ , ${shlibs:Depends}
+Provides: ${nodejs:Provides}
 Description: WebAssembly Binary Toolkit
  WABT (pronounced: "wabbit") is a suite of tools for WebAssembly, including:
  .

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

OUTJS=out/emscripten/Release

# remove some flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
JSFLAGS=hardening=-fortify,-stackprotector,-branch,-bindnow,-stackclash

JSCPPFLAGS:=$(shell DEB_BUILD_MAINT_OPTIONS=$(JSFLAGS) dpkg-buildflags --get CPPFLAGS)
JSCFLAGS:=$(shell DEB_BUILD_MAINT_OPTIONS=$(JSFLAGS) dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
JSCXXFLAGS:=$(shell DEB_BUILD_MAINT_OPTIONS=$(JSFLAGS) dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
JSLDFLAGS:=$(shell DEB_BUILD_MAINT_OPTIONS=$(JSFLAGS) dpkg-buildflags --get LDFLAGS)

WABT_TOOLS:=wasm2c wasm2wat wat2wasm wasm-decompile wasm-interp wasm-objdump wasm-opcodecnt wasm-strip wasm-validate

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTS=OFF
	mkdir -p $(OUTJS)
#disable some hardening flags
	 cd $(OUTJS) && \
	 CFLAGS='$(JSCFLAGS)' \
	 CXXFLAGS='$(JSCXXFLAGS)' \
	 LDFLAGS='$(JSLDFLAGS)' \
	 CPPFLAGS='$(JSCPPFLAGS)' \
		cmake -G Ninja -S ../../.. \
			-B . \
			-DCMAKE_TOOLCHAIN_FILE=/usr/share/emscripten/cmake/Modules/Platform/Emscripten.cmake \
			-DCMAKE_BUILD_TYPE=Release \
			-DBUILD_TESTS=OFF \
			-DCMAKE_VERBOSE_MAKEFILE=ON

execute_before_dh_auto_build:
	cd $(OUTJS) && \
	CFLAGS='$(JSCFLAGS)' \
	CXXFLAGS='$(JSCXXFLAGS)' \
	LDFLAGS='$(JSLDFLAGS)' \
	CPPFLAGS='$(JSCPPFLAGS)' \
		ninja -v
	cp $(OUTJS)/libwabt.js node-wabt-js/index.js
#	mkdir node-wabt-js/bin
#	set -e ; for tool in $(WABT_TOOLS); do \
#		echo '#!/usr/bin/env node' > "node-wabt-js/bin/$$tool"; \
#		cat "$(OUTJS)/$$tool.js" >> "node-wabt-js/bin/$$tool"; \
#		chmod +x "node-wabt-js/bin/$$tool"; \
#	done

execute_after_dh_auto_install:
	dh_auto_install --buildsystem=nodejs

execute_after_dh_installdocs:
	mv debian/wabt.docs debian/_docs
	dh_nodejs_autodocs autodispatch
	mv debian/_docs debian/wabt.docs

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/@ANY_VERSION@(@ARCHIVE_EXT@)$/@PACKAGE@-$1$2/,repacksuffix=+dsfg \
  https://github.com/WebAssembly/wabt/tags .*/@ANY_VERSION@@ARCHIVE_EXT@ group

# exclude nightly version
opts="searchmode=plain,ctype=nodejs,component=node-wabt-js,filenamemangle=s/@ANY_VERSION@$/node-wabt-js-$1.tar.gz/" \
 https://api.github.com/repos/AssemblyScript/wabt.js/tags?per_page=1000 \
 https://api.github.com/repos/AssemblyScript/wabt.js/tarball/refs/tags/v?(\d+(?:\.\d+)*) checksum

## wabt 1.0.36%2Bdfsg%2B~cs1.0.36

=== wasm2c/examples/threads/Makefile ===
#SANITIZERS=-fsanitize=address -fsanitize=undefined -fno-sanitize-recover=all
CFLAGS=-I../.. -g -O2 -Wall -Wextra -Wno-unused -Wno-unused-parameter -Wno-array-bounds -Wno-ignored-optimization-argument -Wno-tautological-constant-out-of-range-compare -Wno-infinite-recursion -fno-optimize-sibling-calls -frounding-math -fsignaling-nans ${SANITIZERS} -pthread
LDLIBS=${SANITIZERS} -pthread -lm

all: threads

clean:
	rm -rf threads sample.wasm sample.c sample.h *.o ../../*.o

threads: threads.o sample.o ../../wasm-rt-impl.o ../../wasm-rt-exceptions-impl.o

sample.wasm: sample.wat ../../../bin/wat2wasm
	../../../bin/wat2wasm --debug-names $< -o $@

sample.c: sample.wasm ../../../bin/wasm2c
	../../../bin/wasm2c $< -o $@

threads.o: sample.c

.PHONY: all clean

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,20 @@
 Source: wabt
 Section: devel
 Priority: optional
-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
-Uploaders: Markus Koschany <apo@debian.org>
- , Bastien Roucariès <rouca@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
+Uploaders: Bastien Roucariès <rouca@debian.org>
  , Yadd <yadd@debian.org>
 Build-Depends: debhelper-compat (= 13)
  , cmake
  , dh-nodejs
- , emscripten
+ , emscripten (>= 3.1.69~)
+ , googletest
+ , libsimde-dev
  , libssl-dev
  , ninja-build
  , python3
+ , python3-ply
  , re2c
 Standards-Version: 4.6.2
 Homepage: https://github.com/WebAssembly/wabt
